from bitcoding import B_dict
from inverse import inv
from solve import solve
#import random
from vbweights import w
from bitcoding import B_dict
from array import array
from counters import counter
from saturate import saturate
from triangulation import MCS, FIC

DALL = B_dict['DALL']

cardmult = max(w)

def findSaturation(ConMatrix, ConMatrixT, neighbors, chordal, pc_only):

   Vars = len(ConMatrix)
   
   edges = set([])
   for i in range(Vars):
      for j in range(i+1,Vars):
         if ConMatrix[i][j] != DALL:
             edges.add((i,j)) 
             if chordal: 
                neighbors[i].add(j)
                neighbors[j].add(i)
   
   if chordal:
      a, a_ = MCS(ConMatrix, neighbors)
      fill = FIC(ConMatrix, neighbors, a, a_)

      for i,j in fill:
          neighbors[i].add(j)
          neighbors[j].add(i)                 

   portfolio = []
   fixes = None
   cutoff = 1 if not solve(tuple([c[:] for c in ConMatrix]), neighbors, chordal, pc_only)[0] else 0 # Number of repairs with which you would be happy; if the QCN is UNSAT, 1 is the lowest bound
   if not cutoff:
      counter['oracle'] += 1 
      return 0, ConMatrix
   for x in range(6+1,1-1,-1):
      fixes, saturation, flag = saturate(ConMatrix, tuple([c[:] for c in ConMatrixT]), set(edges), neighbors, chordal, pc_only, x, fixes)
      if not flag:
         portfolio.append((fixes, saturation))
      if fixes <= cutoff: break
      
   return min(portfolio)       
