from bitcoding import B_dict
from hornsplit import hsplit as split
from inverse import inv
from solve import solve
from counters import counter
from vbweights import w

DALL = B_dict['DALL']

cardmult = max(w)

def saturate(ConMatrix, ConMatrixT, constraintBag, neighbors, chordal, pc_only, model, bound = None):

   if model == 1:
      from models1 import models
   elif model == 2:
      from models2 import models
   elif model == 3:
      from models3 import models
   elif model == 4:
      from models4 import models
   elif model == 5:
      def models(*x): return w[x[-1]-1]
   elif model == 6:
      def models(*x): return split[x[-1]-1][0]
   else: 
      def models(*x): return cardmult*split[x[-1]-1][0] + w[x[-1]-1]

   constraintList = []
   
   fixes = 0
   
   while constraintBag:
      i,j = constraintBag.pop()
      constraintList.append((models(i,j, ConMatrix, ConMatrix[i][j]),(i,j)))
   constraintList.sort(reverse=True)
   
   for i in range(len(constraintList)):
      constraintList[i] = constraintList[i][-1]   

   flag = False
   
   for i,j in constraintList:

      ConMatrixT[i][j] = ConMatrix[i][j]
      ConMatrixT[j][i] = ConMatrix[j][i]
      solution, fail = solve(tuple([c[:] for c in ConMatrixT]), neighbors, chordal, pc_only)
      counter['oracle'] += 1

      if not solution:
         ConMatrixT[i][j] = DALL
         ConMatrixT[j][i] = DALL
         fixes += 1
         if bound and fixes >= bound: 
            flag = True
            break
   
   return fixes, ConMatrixT, flag
