from glob import globs

if globs['pcheuristic'] == 0: # path consistency
   from spc import sPC as pc 
elif globs['pcheuristic'] == 1: # path consistency with weighted queue
   from spcw import sPCw as pc
   
def solve(ConMatrix, neighbors, chordal, pc_only):

   solution = None

   result, fail = pc(ConMatrix, neighbors, chordal)

   if result:
      solution = ConMatrix
      if not pc_only:
            
         if globs['method'] == "rec": 
            from consistency import consistency as consistency
         elif globs['method'] == "iter":
            from iconsistency import iconsistency as consistency
         
         solution, fail = consistency(ConMatrix, neighbors, chordal)
            
   return solution, fail
